Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 580788 - sys-apps/portage-2.2.26: emerge @world does not pick up [rR] slot-operator dependency scheduled for re-emerging
Summary: sys-apps/portage-2.2.26: emerge @world does not pick up [rR] slot-operator de...
Status: RESOLVED OBSOLETE
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Highest normal with 1 vote (vote)
Assignee: Portage team
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: 155723
  Show dependency tree
 
Reported: 2016-04-22 02:14 UTC by Anton Bolshakov
Modified: 2020-02-10 02:03 UTC (History)
4 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
config.tar.xz (config.tar.xz,664.70 KB, application/x-xz)
2016-04-26 06:30 UTC, Anton Bolshakov
Details
debug.log.xz (debug.log.xz,600.77 KB, application/x-xz)
2016-04-26 06:46 UTC, Anton Bolshakov
Details
successful dependency calculation (>=dev-python/ipython-4 masked) (portage-2.2.26.log,33.79 KB, text/plain)
2016-05-09 09:47 UTC, Zac Medico
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Anton Bolshakov 2016-04-22 02:14:01 UTC
emerge -DNupv world

These are the packages that would be merged, in reverse order:

Calculating dependencies... done!
[nomerge       ] pentoo/pentoo-2015.1::pentoo  USE="analyzer cracking database desktop exploit footprint forensics forging fuzzers misc mitm mobile nfc proxies radio rce voip wireless -bluetooth -pentoo -scanner" 
[nomerge       ]  pentoo/pentoo-desktop-2016.1::pentoo  USE="X hardened kde samba -cdr -enlightenment -livecd-stage1 -mate -pentoo -pulseaudio -xfce" 
[ebuild     U ~]   www-client/google-chrome-50.0.2661.86::gentoo [50.0.2661.75::gentoo] USE="plugins" LINGUAS="ru -am -ar -bg -bn -ca -cs -da -de -el -en_GB -es -es_LA -et -fa -fake_bidi -fi -fil -fr -gu -he -hi -hr -hu -id -it -ja -kn -ko -lt -lv -ml -mr -ms -nb -nl -pl -pt_BR -pt_PT -ro -sk -sl -sr -sv -sw -ta -te -th -tr -uk -vi -zh_CN -zh_TW" 47226 KiB
[nomerge       ] pentoo/pentoo-2015.1::pentoo  USE="analyzer cracking database desktop exploit footprint forensics forging fuzzers misc mitm mobile nfc proxies radio rce voip wireless -bluetooth -pentoo -scanner" 
[nomerge       ]  pentoo/pentoo-radio-2015.3-r4::pentoo  USE="-livecd-stage1 -minipentoo -mono" 
[ebuild     U ~]   net-wireless/gnuradio-3.7.9.2:0/3.7.9.2::gentoo [3.7.9:0/3.7.9::gentoo] USE="alsa analog audio channels digital dtv fcd fec filter grc noaa qt4 sdl trellis uhd utils wavelet wxwidgets -atsc -doc -examples -jack -log -oss -pager -performance-counters -portaudio {-test} -vocoder -zeromq" PYTHON_TARGETS="python2_7" 0 KiB
[nomerge       ] pentoo/pentoo-desktop-2016.1::pentoo  USE="X hardened kde samba -cdr -enlightenment -livecd-stage1 -mate -pentoo -pulseaudio -xfce" 
[nomerge       ]  kde-misc/plasma-nm-0.9.3.6:4::gentoo  USE="modemmanager (-aqua) -debug -openconnect" LINGUAS="ru -ar -bg -bs -ca -ca@valencia -cs -da -de -el -en_GB -eo -es -et -fa -fi -fr -ga -gl -hr -hu -is -it -ja -km -ko -lt -lv -mai -mr -ms -nb -nds -nl -nn -pa -pl -pt -pt_BR -ro -sk -sl -sr -sr@ijekavian -sr@ijekavianlatin -sr@latin -sv -th -tr -ug -uk -zh_CN -zh_TW" 
[nomerge       ]   net-libs/libnm-qt-0.9.8.3:0/1::gentoo  USE="modemmanager (-aqua) -debug -doc {-test}" 
[ebuild     U  ]    net-misc/networkmanager-1.0.12-r1::gentoo [1.0.12::gentoo] USE="connection-sharing consolekit dhclient introspection modemmanager ncurses nss ppp wext wifi -bluetooth -dhcpcd -gnutls -resolvconf (-selinux) -systemd -teamd {-test} -vala -zeroconf" ABI_X86="(64) -32 (-x32)" 0 KiB
[ebuild     U  ] sys-devel/gnuconfig-20151214::gentoo [20150727::gentoo] 47 KiB

Total: 4 packages (4 upgrades), Size of downloads: 47273 KiB

!!! Multiple package instances within a single package slot have been pulled
!!! into the dependency graph, resulting in a slot conflict:

net-wireless/gnuradio:0

  (net-wireless/gnuradio-3.7.9.2:0/3.7.9.2::gentoo, ebuild scheduled for merge) pulled in by
    (no parents that aren't satisfied by other packages in this slot)

  (net-wireless/gnuradio-3.7.9:0/3.7.9::gentoo, installed) pulled in by
    >=net-wireless/gnuradio-3.7_rc:0/3.7.9=[fcd,python_targets_python2_7(-),-python_single_target_jython2_7(-),-python_single_target_pypy(-),-python_single_target_pypy3(-),-python_single_target_python3_3(-),-python_single_target_python3_4(-),-python_single_target_python3_5(-),python_single_target_python2_7(+)] required by (net-wireless/gr-osmosdr-0.1.4_p20150730:0/0.1.4_p20150730::gentoo, installed)
                                  ^^^^^^^^^                                                                                                                                                                                                                                                                                                                                                                                                           
    (and 3 more with the same problem)


--------------
emerge --info 
Portage 2.2.26 (python 2.7.10-final-0, hardened/linux/amd64, gcc-4.9.3, glibc-2.22-r4, 4.0.8-pentoo x86_64)
=================================================================
System uname: Linux-4.0.8-pentoo-x86_64-Intel-R-_Core-TM-_i5-3320M_CPU_@_2.60GHz-with-gentoo-2.2
KiB Mem:     7981376 total,   2741556 free
KiB Swap:    4194300 total,   4086276 free
Timestamp of repository gentoo: Thu, 21 Apr 2016 06:00:01 +0000
sh bash 4.3_p42-r1
ld GNU ld (Gentoo 2.25.1 p1.1) 2.25.1
app-shells/bash:          4.3_p42-r1::gentoo
dev-java/java-config:     2.2.0-r3::gentoo
dev-lang/perl:            5.20.2::gentoo
dev-lang/python:          2.7.10-r1::gentoo, 3.4.3-r1::gentoo
dev-util/cmake:           3.3.1-r1::gentoo
dev-util/pkgconfig:       0.28-r2::gentoo
sys-apps/baselayout:      2.2::gentoo
sys-apps/openrc:          0.19.1::gentoo
sys-apps/sandbox:         2.10-r1::gentoo
sys-devel/autoconf:       2.13::gentoo, 2.69::gentoo
sys-devel/automake:       1.14.1::gentoo, 1.15::gentoo
sys-devel/binutils:       2.25.1-r1::gentoo
sys-devel/gcc:            4.9.3::gentoo
sys-devel/gcc-config:     1.7.3::gentoo
sys-devel/libtool:        2.4.6::gentoo
sys-devel/make:           4.1-r1::gentoo
sys-kernel/linux-headers: 4.3::gentoo (virtual/os-headers)
sys-libs/glibc:           2.22-r4::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: rsync
    sync-uri: rsync://rsync.gentoo.org/gentoo-portage
    priority: -1000

steam-overlay
    location: /var/lib/layman/steam-overlay
    masters: gentoo
    priority: 0

pentoo
    location: /var/lib/layman/pentoo
    masters: gentoo
    priority: 1

local-overlay
    location: /usr/local/portage
    masters: gentoo
    priority: 2

ABI="amd64"
ABI_X86="64"
ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="* -@EULA PUEL AdobeFlash-11.x Google-TOS dlj-1.1 google-chrome Oracle-BCLA-JavaSE Intel-SDP skype-4.0.0.7-copyright baudline"
ACCEPT_PROPERTIES="*"
ACCEPT_RESTRICT="*"
ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci"
ANDROID_HOME="/opt/android-sdk-update-manager"
ANDROID_SWT="/usr/share/swt-3.7/lib"
ANT_HOME="/usr/share/ant"
APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias"
ARCH="amd64"
AUTOCLEAN="yes"
BOOTSTRAP_USE="cxx unicode internal-glib python_targets_python3_4 python_targets_python2_7 multilib hardened pax_kernel pic xtpax -jit -orc"
CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author"
CAMERAS="ptp2"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=native -O2 -pipe"
CFLAGS_amd64="-m64"
CFLAGS_x32="-mx32"
CFLAGS_x86="-m32"
CHOST="x86_64-pc-linux-gnu"
CHOST_amd64="x86_64-pc-linux-gnu"
CHOST_x32="x86_64-pc-linux-gnux32"
CHOST_x86="i686-pc-linux-gnu"
CLEAN_DELAY="5"
COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog"
COLLISION_IGNORE="/lib/modules/* *.py[co] *$py.class */dropin.cache"
CONFIG_PROTECT="/etc /etc/stunnel/stunnel.conf /opt/sonar/conf /usr/share/config /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CPU_FLAGS_X86="aes avx mmx mmxext popcnt sse sse2 sse3 sse4_1 sse4_2 ssse3"
CXXFLAGS="-march=native -O2 -pipe"
DEFAULT_ABI="amd64"
DISPLAY=":0"
DISTDIR="/usr/portage/distfiles"
EDITOR="/usr/bin/mcedit"
ELIBC="glibc"
EMERGE_DEFAULT_OPTS=" --ask-enter-invalid --keep-going=y --binpkg-respect-use=y --tree --verbose --with-bdeps=y --autounmask=n --buildpkg-exclude "sys-kernel/compat-drivers sys-kernel/ax88179_178a x11-drivers/ati-drivers x11-drivers/nvidia-drivers sys-fs/zfs-kmod sys-kernel/spl                      sys-power/bbswitch pentoo/pentoo-installer x11-drivers/xf86-video-virtualbox app-emulation/virtualbox-guest-additions                         app-emulation/virtualbox-modules app-emulation/vmware-modules app-emulation/open-vm-tools-kmod sys-kernel/genkernel sys-kernel/pentoo-sources" --usepkg-exclude "sys-kernel/compat-drivers sys-kernel/ax88179_178a x11-drivers/ati-drivers x11-drivers/nvidia-drivers sys-fs/zfs-kmod sys-kernel/spl                     sys-power/bbswitch pentoo/pentoo-installer x11-drivers/xf86-video-virtualbox app-emulation/virtualbox-guest-additions         app-emulation/virtualbox-modules app-emulation/vmware-modules app-emulation/open-vm-tools-kmod sys-kernel/genkernel sys-kernel/pentoo-sources""
EMERGE_WARNING_DELAY="10"
EPREFIX=""
EROOT="/"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs config-protect-if-modified distlocks ebuild-locks fixlafiles merge-sync news parallel-fetch preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FETCHCOMMAND="wget -t 3 -T 60 --passive-ftp -O "${DISTDIR}/${FILE}" "${URI}""
Comment 1 Rick Farina (Zero_Chaos) gentoo-dev 2016-04-22 19:57:59 UTC
portage subslot dep calculation failure?
Comment 2 Anton Bolshakov 2016-04-23 02:52:33 UTC
Somehow, with "world" portage does not detect that few deps need to be rebuilt too. Here is what I have on gnuradio upgrade specifically:

bash# emerge -pv gnuradio 

These are the packages that would be merged, in reverse order:

Calculating dependencies... done!
[ebuild  rR   *] net-wireless/gr-air-modes-9999::pentoo  USE="gui -fgfs -rtl -uhd" PYTHON_TARGETS="python2_7" 0 KiB
[ebuild  rR   ~] net-wireless/gqrx-2.5::gentoo  USE="-pulseaudio" 0 KiB
[ebuild  rR   ~]  net-wireless/gr-osmosdr-0.1.4_p20150730:0/0.1.4_p20150730::gentoo  USE="fcd hackrf iqbalance python rtlsdr uhd -bladerf (-mirisdr)" PYTHON_TARGETS="python2_7" 0 KiB
[ebuild  rR   ~]   net-wireless/gr-iqbal-0.37.2:0/0.37.2::gentoo  PYTHON_TARGETS="python2_7" 0 KiB
[ebuild  r  U ~]    net-wireless/gnuradio-3.7.9.2:0/3.7.9.2::gentoo [3.7.9:0/3.7.9::gentoo] USE="alsa analog audio channels digital dtv fcd fec filter grc noaa qt4 sdl trellis uhd utils wavelet wxwidgets -atsc -doc -examples -jack -log -oss -pager -performance-counters -portaudio {-test} -vocoder -zeromq" PYTHON_TARGETS="python2_7" 0 KiB

Total: 5 packages (1 upgrade, 4 reinstalls), Size of downloads: 0 KiB

The following packages are causing rebuilds:

  (net-wireless/gnuradio-3.7.9.2:0/3.7.9.2::gentoo, ebuild scheduled for merge) causes rebuilds for:
    (net-wireless/gr-air-modes-9999:0/0::pentoo, ebuild scheduled for merge)
    (net-wireless/gr-osmosdr-0.1.4_p20150730:0/0.1.4_p20150730::gentoo, ebuild scheduled for merge)
    (net-wireless/gr-iqbal-0.37.2:0/0.37.2::gentoo, ebuild scheduled for merge)
    (net-wireless/gqrx-2.5:0/0::gentoo, ebuild scheduled for merge)
Comment 3 Anton Bolshakov 2016-04-26 06:30:00 UTC
Created attachment 432032 [details]
config.tar.xz

the output of the following command:
tar -cJf /tmp/config.tar.xz -C / ./etc/portage ./var/db/pkg ./var/lib/portage/world --exclude CONTENTS --exclude environment.bz2 --exclude 'NEEDED*' --exclude '*.ebuild'
Comment 4 Anton Bolshakov 2016-04-26 06:31:22 UTC
Since there is no progress so far and the bug might not be fix soonest, I'm going to upgrade gnuradio manually. I'm attaching some configs (copied from bug #566024) with a hope that it will help to reproduce the problem.
Comment 5 Anton Bolshakov 2016-04-26 06:46:30 UTC
Created attachment 432034 [details]
debug.log.xz

output of the following: emerge -DNUupv --with-bdeps=y --debug world > debug.log 2>&1 xz -9 debug.log
Comment 6 Anton Bolshakov 2016-04-26 07:17:47 UTC
There is one more package got blocked with the similar problem after recent sync:

app-text/poppler:0

  (app-text/poppler-0.42.0:0/59::gentoo, ebuild scheduled for merge) pulled in by
    (no parents that aren't satisfied by other packages in this slot)

  (app-text/poppler-0.32.0:0/51::gentoo, installed) pulled in by
    app-text/poppler:0/51 required by (app-office/libreoffice-bin-5.0.5.2-r1:0/0::gentoo, installed)
                    ^^^^^                      
          
    >=app-text/poppler-0.12.3-r3:0/51= required by (app-text/texlive-core-2014-r4:0/0::gentoo, installed)
                                ^^^^^^                                                                                                       
    (and 2 more with the same problems)
Comment 7 Anton Bolshakov 2016-04-30 04:24:03 UTC
I keyworded app-office/libreoffice-bin-5.1.2.2 (it is compiled against the currently stable poppler) and the same problem show up. emerge -1 libreoffice-bin worked, but "emerge -DNu @world" didn't work.
Comment 8 Anton Bolshakov 2016-05-08 14:49:21 UTC
we have yet another user with the same problem, but the list of problematic packages is bigger:

https://bpaste.net/show/4ed26dc3520f
Comment 9 Anton Bolshakov 2016-05-08 14:53:55 UTC
Does anybody look at the bug? The bug sounds very critical.
Comment 10 Zac Medico gentoo-dev 2016-05-08 21:21:45 UTC
(In reply to Anton Bolshakov from comment #9)
> Does anybody look at the bug? The bug sounds very critical.

Today I plan to see if I can use your configuration to reproduce it.

As a workaround, typically you can use the --verbose-conflicts option to see which packages need to rebuilt, and you can rebuild them manually. Alternatively, you can use the --ignore-built-slot-operator-deps=y option to temporarily ignore the conflict. If you do that, then the rebuilds might trigger automatically on the next emerge run.

(In reply to Anton Bolshakov from comment #8)
> we have yet another user with the same problem, but the list of problematic
> packages is bigger:
> 
> https://bpaste.net/show/4ed26dc3520f

Yeah, that could be the same bug.
Comment 11 Zac Medico gentoo-dev 2016-05-09 02:10:31 UTC
(In reply to Anton Bolshakov from comment #3)
> Created attachment 432032 [details]
> config.tar.xz
> 
> the output of the following command:
> tar -cJf /tmp/config.tar.xz -C / ./etc/portage ./var/db/pkg
> ./var/lib/portage/world --exclude CONTENTS --exclude environment.bz2
> --exclude 'NEEDED*' --exclude '*.ebuild'

With your configuration, it looks like I'm getting similar results. I'm using these repos:

gentoo e272bacc12364f633ee7a3b8024aaa117011a708
pentoo 4f1c01d19c2a91193ae5b0e1270d98970aeabd54

I'm testing with portage-2.2.28, since I want to eliminate interactions from bug 566024 and bug 567686.

Using emerge -DNupv world, I see what look like solvable slot conflicts for ncurses, poppler, and gnuradio. If I add the --changed-deps option, the ncurses conflict is the only one that remains. I will investigate why these conflicts are not solved.
Comment 12 Zac Medico gentoo-dev 2016-05-09 09:28:51 UTC
(In reply to Zac Medico from comment #11)
> Using emerge -DNupv world, I see what look like solvable slot conflicts for
> ncurses, poppler, and gnuradio. If I add the --changed-deps option, the
> ncurses conflict is the only one that remains. I will investigate why these
> conflicts are not solved.

Eventually, I figured out that this blocker was the only thing preventing it from solving:

[blocks B      ] <dev-python/ipython-4.0.0[smp] ("<dev-python/ipython-4.0.0[smp]" is blocking dev-python/ipyparallel-5.0.1)

With portage-2.2.28 it solved after putting '>=dev-python/ipython-4' in package.mask.

I still need to test this configuration with portage-2.2.26, to see if bug 566024 and/or bug 567686 may be involved.
Comment 13 Zac Medico gentoo-dev 2016-05-09 09:37:01 UTC
(In reply to Anton Bolshakov from comment #8)
> we have yet another user with the same problem, but the list of problematic
> packages is bigger:
> 
> https://bpaste.net/show/4ed26dc3520f

Looking at this again, it fails due to an unsatisfied dependency:

emerge: there are no ebuilds to satisfy "net-analyzer/wireshark:0/1.12.8=[lua]".
(dependency required by "net-analyzer/cloudshark-1.0.4::gentoo" [installed])

The means the dependency calculation didn't finish, and the slot conflicts might have solved if the dependency calculation run to completion. I know that this is not obvious to users, so we should do something about that.
Comment 14 Zac Medico gentoo-dev 2016-05-09 09:47:53 UTC
Created attachment 433756 [details]
successful dependency calculation (>=dev-python/ipython-4 masked)

I get the same results with 2.2.26 and 2.2.28, so it doesn't seem like bug 566024 or bug 567686 are involved.
Comment 15 Zac Medico gentoo-dev 2016-05-09 09:54:02 UTC
Actually, maybe bug 566024 or bug 567686 played a role, but I didn't reproduce that result. It's possible for hash randomization to affect dependency resolver outcomes.
Comment 16 Anton Bolshakov 2020-02-10 02:03:57 UTC
It were way to many changes in portage since 2016 so I guess nobody would be able to reproduce or fix this bug.